---
layout: section
---
# Real World Microcontrollers
Intel / AVR / PIC / TriCore / ARM Cortex-M / RISC-V rv32i(a)mc

---
---
# Bibliography
for this section

**Joseph Yiu**, *The Definitive Guide to ARM® Cortex®-M0 and Cortex-M0+ Processors, 2nd Edition*
   - Chapter 1 - *Introduction*
   - Chapter 2 - *Technical Overview*

---
---
# Intel

<div grid="~ cols-2 gap-4">
<div>

| | |
|-|-|
| Vendor | Intel |
| ISA | 8051, 8051 |
| Word | 8 bit |
| Frequency | a few MHz |
| Storage | ? |
| Variants | *8048*, *8051* |

</div>

<img src="./intel_8051.jpg" class="h-80 rounded" />

</div>

---
---
# AVR
probably *Alf and Vegard's RISC processor*

<div grid="~ cols-2 gap-4">
<div>

| | |
|-|-|
| Authors | Alf-Egil Bogen and Vegard Wollan |
| Vendor | Microchip (*Atmel*) |
| ISA | AVR |
| Word | 8 bit |
| Frequency | 1 - 20 MHz |
| Storage | 4 - 256 KB |
| Variants | *ATmega*, *ATtiny* |

</div>

<div>
    <img src="./atmega_328.jpg" class="h-50 rounded" />
    Board
    <img src="./arduino_uno.jpg" class="h-45 rounded" />
</div>

</div>

---
---
# PIC
Peripheral Interface Controller / Programmable Intelligent Computer

<div grid="~ cols-2 gap-4">
<div>

| | |
|-|-|
| Vendor | Microchip |
| ISA | PIC |
| Word | 8 - 32 |
| Frequency | 1 - 20 MHz |
| Storage | 256 B - 64 KB |
| Variants | *PIC10*, *PIC12*, *PIC16*, *PIC18*, *PIC24*, *PIC32* |

</div>

<img src="./pic.jpg" class="h-50 rounded" />

</div>

---
---
# TriCore

<div grid="~ cols-2 gap-4">
<div>

| | |
|-|-|
| Vendor | Infineon |
| ISA | AURIX32 |
| Word | 32 bit |
| Frequency | hundreds of MHz |
| Storage | a few MB |
| Variants | *TC2xx*, *TC3xx*, *TC4xx* |

</div>

<img src="./tricore.png" class="h-50" />

</div>

---

# ARM Cortex-M
Advanced RISC Machine

<div grid="~ cols-2 gap-4">
<div>

| | |
|-|-|
| Vendor | Qualcomm, NXP, Nordic Semiconductor, Broadcom, Raspberry Pi |
| ISA | ARMv6-M (Thumb and some Thumb-2) <br/> ARMv7-M (Thumb and Thumb-2) <br/> ARMv8-M (Thumb and Thumb-2) |
| Word | 32 |
| Frequency | 1 - 900 MHz |
| Storage | up to a few MB |
| Variants | *M0*, *M0+*, *M3*, *M4*, *M7*, *M23*, *M33* |

</div>

<img src="./arm_logo.png" class="h-20" />

</div>

---
layout: two-cols
---
# ARM Cortex-M Instruction Set
what the MCU can do

**Fun Facts**

<v-clicks>

- M0/M0+ has no `div`
- M0 - M3 have no floating point
- M23 and M33 have security extensions

</v-clicks>

<style>
.two-columns {
    grid-template-columns: 3fr 6fr;
}
</style>

::right::

<img src="./arm_cortex_m_instruction_set.png" class="h-125" />

---
---
# RISC-V rv32i(a)mc
Fifth generation of RISC ISA

<div grid="~ cols-2 gap-4">
<div>

| | |
|-|-|
| Authors | University of California, Berkeley |
| Vendor | Espressif System  |
| ISA | rv32i(a)mc |
| Word | 32 bit |
| Frequency | 1 - 200 MHz |
| Storage | 4 - 256 KB |
| Variants | *rv32imc*, *rv32iamc* |

</div>

<img src="./risc-v_logo.png" class="h-60" />

</div>
